module odejmowanie(
    input  logic        rst,
    input  logic        clk,
    input  logic [255:0]  a,
    input  logic [255:0]  b,
    input  logic         enable,
    input  logic         clear,
    output  logic         result_valid,
    output  logic [255:0]  result

);

//====================================================
//=======  NUMBERS SUBTRACTION  =======================
//====================================================
always @ (posedge clk or posedge rst)
 begin : REJESTR_ODEJMOWANIE
   if (rst == 1'b1) begin
        result <= 256'b0;
        result_valid <= 1'b0;
   end else begin
        result_valid <= enable;
        
        if (enable == 1'b1) begin
            result <= a - b;
        end 
        else if (clear == 1'b1) begin
            result <= 256'b0;
        end
   end
 end

endmodule