module sumator(
    input  logic        rst,
    input  logic        clk,
    input  logic [1023:0]  a,
    input  logic [1023:0]  b,
    input  logic         enable,
    input  logic         clear,
    output  logic         c_valid,
    output  logic [1023:0]  c

);

//====================================================
//=======  NUMBERS ADDITION  =======================
//====================================================
always @ (posedge clk or posedge rst)
 begin : REJESTR_SUMATORA
   if (rst == 1'b1) begin
        c <= 1024'b0;
        c_valid <= 1'b0;
   end else begin
        c_valid <= enable;
        
        if (enable == 1'b1) begin
            c <= a + b;
        end 
        else if (clear == 1'b1) begin
            c <= 1024'b0;
        end
   end
 end

endmodule