transcript on

vlib work
vmap work

vlog -sv -work work +incdir+./svunit_base {./svunit_base/svunit_pkg.sv}

vlog -sv -work work +incdir+./svunit_base {./key_generator_unit_test.sv}

vlog -sv -work work +incdir+./svunit_base {./key_generator_unit_test_runner.sv}

vlog -sv -work work {../modul_key_generator.sv}

vlog -sv -work work {../modul_increment.sv}

vlog -sv -work work {../modul_odejmowania.sv}

vlog -sv -work work {../modul_mnozenia.sv}

vlog -sv -work work {../mult.sv}

vlog -sv -work work {../divider.sv}

vsim -suppress 12003,8386,8440 -t 1ps -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L fiftyfivenm_ver -L work -sv_seed random -voptargs="+acc" key_generator_unit_test_runner

do key_generator_wave.do

view structure
view signals
run -all