transcript on

vlib work
vmap work

vlog -sv -work work {./rdl/registers_pkg.sv}
vlog -sv -work work {./rdl/registers.sv}

vlog -sv -work work {./axi_lite/axi4_lite_pkg.sv}
vlog -sv -work work {./axi_lite/axi4_lite_if.sv}

vlog -sv -work work +incdir+./axi_lite {./axi_lite/unit_test_pkg.sv}

vlog -sv -work work +incdir+./svunit_base {./svunit_base/svunit_pkg.sv}

vlog -sv -work work +incdir+./svunit_base {./top_unit_test.sv}

vlog -sv -work work +incdir+./svunit_base {./top_unit_test_runner.sv}

vlog -sv -work work {../modul_studenta.sv}

vlog -sv -work work {../modul_sumator.sv}

vlog -sv -work work {../modul_mnozenia.sv}

vlog -sv -work work {../divider.sv}

vlog -sv -work work {../mult.sv}

vlog -sv -work work {../modul_increment.sv}

vlog -sv -work work {../modul_key_generator.sv}


vsim -suppress 12003,8386,8440 -t 1ps -L altera_ver -L lpm_ver -L sgate_ver -L altera_mf_ver -L altera_lnsim_ver -L fiftyfivenm_ver -L work -sv_seed random -voptargs="+acc" top_unit_test_runner

do wave.do

view structure
view signals
run -all