module increment(
    input  logic        rst,
    input  logic        clk,
    input  logic [511:0]  value,
    input  logic         enable,
    input  logic         clear,
    output  logic         result_valid,
    output  logic [511:0]  result
);

//====================================================
//=======  NUMBERS ADDITION  =======================
//====================================================
always @ (posedge clk or posedge rst)
 begin : REJESTR_INCREMENT
   if (rst == 1'b1) begin
        result <= 512'b0;
        result_valid <= 1'b0;
   end else begin
        result_valid <= enable;
        
        if (enable == 1'b1) begin
            result <= value + 1;
        end 
        else if (clear == 1'b1) begin
            result <= 512'b0;
        end
   end
 end

endmodule