transcript on

vlib work
vmap work

vlog -sv -work work +incdir+../common/avalon {../common/avalon/avalon_mm_pkg.sv}

vlog -sv -work work +incdir+../common/avalon {../common/avalon/unit_test_pkg.sv}

vlog -sv -work work +define+SIMULATION +incdir+../common/avalon {../../rtl/common/dc_fifo.sv}

vlog -sv -work work +incdir+../common/svunit_base {../common/svunit_base/svunit_pkg.sv}

vlog -sv -work work +incdir+../common/svunit_base+../include {./divider.sv}

vlog -sv -work work +incdir+../common/svunit_base+../include {./divider_unit_test.sv}

vlog -sv -work work +incdir+../common/svunit_base {./divider_unit_test_runner.sv}

vsim -modelsimini /apps/altera/pro/18.0.1/modelsim.ini \
     -suppress 12003,8386,8440 \
     -t 1ps \
     -L altera_ver \
     -L lpm_ver \
     -L sgate_ver \
     -L altera_mf_ver \
     -L altera_lnsim_ver \
     -L fourteennm_ver \
     -L fourteennm_ct1_ver \
     -L work \
     -sv_seed random \
     -voptargs="+acc" \
     divider_unit_test_runner

do wave.do

view structure
view signals
run -all